import numpy as np
from sklearn.model_selection import train_test_split

# Leo los datos
D = np.loadtxt( "datos.txt" )
print( D.shape )

n, m = D.shape

# Construimos la matriz del modelo
# Para un parámetro (una linea)
# Para dos parámetros  x^2 x
# Para tres parámetros  x^3 x^2 x

# Para ajustar a una cúbica
X = np.ones( (n, 4) )
X[:,0] = D[:,0] * D[:,0] * D[:,0]
X[:,1] = D[:,0] * D[:,0]
X[:,2] = D[:,0]

# Separamos los datos en datos de entrenamiento
# y datos de prueba
#
X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, D[:,1], random_state=2 )

# Vamos a calcular la solución usando la descomposición
# QR

# X_entrena w = b
# Y necesitamos encontrar el vector w

# Hacemos la matriz aumentada [ X_entrena, b ]

A = np.concatenate( (X_entrena, y_entrena.reshape(-1,1) ), axis=1 )

R = np.linalg.qr( A, mode='r' )
# print( R )

# La retrosustitución
n = 3

vx = np.zeros( (n+1,) )

vx[n] = R[n,n+1] / R[n,n]
k = n-1
while k >= 0 :
	suma = 0.0
	i = k+1
	while i <= n :
		suma += R[k,i]*vx[i]
		i += 1
	vx[k] = (R[k,n+1] - suma)/R[k,k]
	k -= 1

print( vx ) 
